#
# spec file for package clamav
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bc bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libgssapi libmudflap libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions pkgconfig popt post-build-checks procinfo procmail procps psmisc pwdutils rcs readline rpm sed sendmail sendmail-devel strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel


Name:           clamav
BuildRequires:  ncurses-devel sed sendmail sendmail-devel openssl-devel libxml2-devel
%if 0%{?suse_version} >= 1010
BuildRequires:  bc pkgconfig zlib-devel
%endif
%if 0%{?suse_version} >= 1030
BuildRequires:  check-devel pwdutils
%define clamav_check --enable-check
%else
%define clamav_check --disable-check
%endif
Summary:        Antivirus Toolkit
Version:        0.98.5
Release:        15.1
License:        GPL v2 or later
Group:          Productivity/Security
Url:            http://www.clamav.net
%if 0%{?suse_version}
Requires:       latex2html-pngicons
%else
Requires:	latex2html
%endif
Obsoletes:      clamav-db < 0.88.3
PreReq:         %_sbindir/groupadd %_sbindir/useradd %_sbindir/usermod
PreReq:         /usr/bin/awk /bin/sed /bin/tar
%if 0%{?suse_version}
PreReq:         %insserv_prereq
%endif
Source0:        %{name}-%{version}.tar.bz2
Source1:        clamav-rcclamd
Source2:        clamav-rcfreshclam
Source3:        clamav-updateclamconf
Source4:        clamav-rpmlintrc
Source5:        clamav-rcmilter
Patch1:         clamav-conf-0.98.3.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Clam AntiVirus is an antivirus toolkit for UNIX. The main purpose of
this software is the integration with mail servers (attachment
scanning). The package provides a flexible and scalable multithreaded
daemon, a command line scanner, and a tool for automatic updating via
the Internet. It can be used in conjunction with AMaViSD-new and
Postfix to provide a combined e-mail filter for spam and viruses.



Authors:
--------
    Tomasz Kojm
    Nigel Horne

%debug_package
%package db
License:        GPL v2 or later
Group:          Productivity/Security
Summary:        Virus Database for ClamAV
PreReq:         clamav sed /bin/cp /usr/bin/awk /bin/rm

%description db
This package contains a snapshot of the virus description database for
ClamAV. It is not needed if you use freshclam to keep your virus
database up to date.



Authors:
--------
    Tomasz Kojm
    Nigel Horne

%prep
%setup -q
%patch1

%build
%if 0%{?suse_version} >= 1010
CFLAGS="-fstack-protector"
%endif
export CFLAGS="%optflags -fno-strict-aliasing $CFLAGS"
%if 0%{?suse_version} == 0910
# SLES9 needs this macro to enable the quarantine feature in libmilter
CFLAGS="$CFLAGS -D_FFR_QUARANTINE"
%endif
./configure \
	--prefix=%_prefix \
	--libdir=%_libdir \
	--mandir=%_mandir \
	--sysconfdir=%_sysconfdir \
	--disable-clamav \
	--disable-static \
	--with-dbdir=/var/lib/clamav \
	--with-user=vscan \
	--with-group=vscan \
	--enable-milter \
	%clamav_check \
	--disable-zlib-vcheck
make %{?jobs:-j%jobs}

%check
VALGRIND_GENSUP=1 make check

%install
%__make DESTDIR=%{buildroot} install
ln -sf docs/html/{clamdoc,index}.html
mkdir -p %buildroot/etc/init.d
install -m755 %SOURCE1 %buildroot/etc/init.d/clamd
ln -s /etc/init.d/clamd %buildroot%_sbindir/rcclamd
install -m755 %SOURCE2 %buildroot/etc/init.d/freshclam
ln -s /etc/init.d/freshclam %buildroot%_sbindir/rcfreshclam
install -m755 %SOURCE5 %buildroot/etc/init.d/clamav-milter
ln -s /etc/init.d/clamav-milter %buildroot%_sbindir/rcclamav-milter
install -m755 %SOURCE3 %buildroot%_sbindir/updateclamconf
mkdir -p %buildroot/var/lib/clamav
touch %buildroot/var/lib/clamav/{clamd,freshclam}.pid
#for f in %buildroot/var/lib/clamav/*.cvd; do
#	mv $f $f.dist
#	touch $f
#done
touch %buildroot/var/lib/clamav/{main,daily}.cld
mkdir -p %buildroot/var/spool/amavis
%if 0%{?suse_version} > 1020
rm %buildroot/%_libdir/*.la
%endif
# Remove bogus dependencies from libclamav.pc
sed -i 's/^Libs: .*/Libs: -lclamav/' %buildroot%_libdir/pkgconfig/libclamav.pc
cd %{buildroot}%{_sysconfdir}
for a in `ls -1A *.conf.sample` ; do
 cp $a `basename $a .sample`
done
%clean
rm -rf %buildroot

%files
%defattr(-,root,root,-)
%config(noreplace) %_sysconfdir/*.conf
%config %{_sysconfdir}/*.conf.sample
%config %attr(744,root,root)/etc/init.d/*
%doc AUTHORS BUGS ChangeLog COPYING FAQ NEWS README UPGRADE
%doc docs/*.pdf docs/html
%doc %_mandir/*/*
%_bindir/*
%_sbindir/*
%_includedir/*
%_libdir/lib*
%_libdir/pkgconfig/libclamav.pc
%defattr(-,vscan,vscan)
%dir %attr(700,vscan,root) /var/spool/amavis
%dir /var/lib/clamav
%ghost /var/lib/clamav/*.pid
%ghost /var/lib/clamav/*.cld
##%ghost /var/lib/clamav/*.cvd

%files db
%defattr(-,vscan,vscan)
%dir /var/lib/clamav
##/var/lib/clamav/*.cvd.dist

%pre
%_sbindir/groupadd -r vscan 2> /dev/null || :
%_sbindir/useradd -r -o -g vscan -u 65 -s /bin/false -c "Vscan account" -d /var/spool/amavis vscan 2> /dev/null || :
%_sbindir/usermod vscan -g vscan 2> /dev/null || :

%post
/sbin/ldconfig
# merge config files on update
test "0$1" -lt 2 && exit 0
umask 022
for f in /etc/clamd.conf /etc/freshclam.conf /etc/clamav-milter.conf; do
  if test -e $f.rpmnew; then
    echo "Merging $f and $f.rpmnew"
    %_sbindir/updateclamconf -v override="$OVERRIDE" $f $f.rpmnew > $f.tmp
    if test $? == 0; then
      mv $f $f.old
      mv $f.tmp $f
    else
      echo "Merging $f with $f.rpmnew failed"
    fi
  fi
done
# convert virus database file format when updating from < 0.93
DBDIR=$(awk '/^[[:space:]]*DatabaseDirectory/{print $NF}' /etc/clamd.conf)
cd ${DBDIR:=/var/lib/clamav}
umask 022
TMPFILE=$PWD/tmp.$$
for type in main daily; do
    rm -f $TMPFILE
    if test ! -f $type.cvd -a ! -f $type.cld -a -d $type.inc; then
	cd $type.inc
	test -f COPYING -a -f $type.info -a -f $type.db \
	    -a -f $type.hdb -a -f $type.mdb -a -f $type.ndb \
	    -a -f $type.zmd -a -f $type.fp || continue
	awk 'NR==1{printf $0; for (i=length($0); i<512; i++) printf " "}' \
	    $type.info > $TMPFILE || continue
	tar -c -f- COPYING $type.info $type.db $type.hdb $type.mdb \
	    $type.ndb $type.zmd $type.fp >> $TMPFILE || continue
	cd ..
	if test -f $TMPFILE; then
	    chown --reference $type.inc $TMPFILE 2>/dev/null
	    mv $TMPFILE $type.cld
	fi
    fi
done
rm -f $TMPFILE

%triggerpostun -- %name < 0.88.3
# Move clamav.conf to clamd.conf when updating from an old version
# and inform the admin about the rename.
cd /etc
if test -e clamav.conf.rpmsave -a ! -e clamd.conf.rpmnew; then
   mv clamd.conf clamd.conf.rpmnew
   mv clamav.conf.rpmsave clamd.conf
   cat > clamav.conf <<-EOF
	# clamd.conf has been renamed to clamav.conf.
	# This file can be removed.
	EOF
   %restart_on_update clamd
fi

%preun
%stop_on_removal clamd freshclam

%postun
/sbin/ldconfig
%restart_on_update clamd freshclam
%insserv_cleanup

%post db
# determine the version number of a given database file
getversion() {
  if test -f "$1"; then
    /usr/bin/sigtool -i "$1" | sed -n '/^Version: /s///gp'
  else
    # a non-existing file is assumed to have version 0
    echo 0
  fi
}
DBDIR=$(awk '/^[[:space:]]*DatabaseDirectory/{print $NF}' /etc/clamd.conf)
cd ${DBDIR:=/var/lib/clamav}
for f in main daily; do
  vdist=$(getversion $f.cvd.dist)
  vcvd=$(getversion $f.cvd)
  vcld=$(getversion $f.cld)
  v=$((vcld > vcvd ? vcld : vcvd))
  if test $vdist -gt $v; then
    cp -a $f.cvd.dist $f.cvd
    rm -f $f.cld
  fi
done

%changelog
* Sun Nov 23 2014 cs@linux-administrator.com
- Update to release 0.98.5
* Sun Jul 13 2014 cs@linux-administrator.com
- Update to release 0.98.4
* Fri May  9 2014 cs@linux-administrator.com
- Update to release 0.98.3
- rework config patch
* Fri Jan 17 2014 cs@linux-administrator.com
- Update to release 0.98.1
- rework config patch
* Fri Sep 20 2013 cs@linux-administrator.com
- Update to release 0.98
- rework config patch
* Tue Apr 23 2013 cs@linux-administrator.com
- Update to release 0.97.8
* Fri Mar 15 2013 cs@linux-administrator.com
- Update to release 0.97.7
* Tue Sep 18 2012 cs@linux-administrator.com
- Update to release 0.97.6
* Sat Jun 16 2012 cs@linux-administrator.com
- Update to release 0.97.5
* Fri Mar 16 2012 cs@linux-administrator.com
- Update to release 0.97.4
* Tue Oct 18 2011 cs@linux-administrator.com
- Update to release 0.97.3
